﻿using System.Collections.Generic;
using System.Linq;
using NHibernate.Linq;
using System.Web.Mvc;
using Telerik.Web.Mvc;
using TelerikMvcGridCustomBindingHelper;
using TelerikMvcGridCustomBindingHelper.NHibernate;
using TelerikMvcGridNHibernate.Models;

namespace TelerikMvcGridNHibernate.Controllers
{
    //[HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        #region Standard Ajax Binding
        public ActionResult StandardAjax()
        {
            return View();
        }

        [GridAction]
        public ActionResult _StandardAjaxQuery()
        {
            //doesn't work for grouping with nhibernate
            var orders = MvcApplication.NorthwindSession.Query<Order>();

            return View(new GridModel(orders));
        }
        #endregion

        #region Custom Server Binding
        [GridAction(GridName = "Grid")]
        public ActionResult CustomServer(GridCommand command)
        {
            var query = MvcApplication.NorthwindSession.Query<Order>();
            var gridHelper = new GridCustomBindingHelper<Order, OrderViewModel>(command, query);
            var gridModel = gridHelper.BuildGridModel();

            return View(gridModel);
        }
        #endregion

        #region Custom Ajax Binding
        public ActionResult CustomAjax()
        {
            return View();
        }

        [GridAction(EnableCustomBinding = true)]
        public ActionResult _CustomAjaxQuery(GridCommand command)
        {
            var query = MvcApplication.NorthwindSession.Query<Order>();
            var gridHelper = new GridCustomBindingHelper<Order, OrderViewModel>(command, query);
            var gridModel = gridHelper.BuildGridModel();

            return View(gridModel);
        }
        #endregion

        #region QueryOver
        [GridAction(GridName = "Grid")]
        public ActionResult QueryOver(GridCommand command)
        {
            //TelerikMvcGridCustomBindingHelper.NHibernate required for this to work
            var query = MvcApplication.NorthwindSession.QueryOver<Order>();
            var gridHelper = new NHibernateGridCustomBindingHelper<Order, OrderViewModel>(command, query);
            var gridModel = gridHelper.BuildGridModel();

            return View(gridModel);
        }
        #endregion
    }
}
